#ifndef FILTERLOADER_H
#define FILTERLOADER_H

#include <QObject>
#include "filterinterface.h"
#include <QMap>
struct Filter
{
    FilterInterface *filter;
    QString description;
    QString author;
};

//The class deals with the filters.

class FilterLoader : public QObject
{
    Q_OBJECT
public:
    explicit FilterLoader(QObject *parent = 0);
    Filter getFilter(QString id) const;
signals:
    void filterReady(QString displayableName,QString id);
public slots:
private:
    //a List of available filters accessed through an id
    QMap<QString,Filter> mFilters;
    bool hasInitialized;
public:
    void loadFilters();
private:
    QStringList fetchFilterSpecs();

    void parseSpec(QString file);

    bool loadFilter(QString);

};

#endif // FILTERLOADER_H
