#include "appwindow.h"
#include "workspace.h"
#include <QDockWidget>
#include <QToolBar>
#include <QMenuBar>


AppWindow::AppWindow(QWidget *parent):QMainWindow(parent)
{
    mWorkspace=new Workspace();
    setCentralWidget(mWorkspace);
    createActions();
    createMenus();
    createToolBars();
    createStatusBar();
    readSettings();
}

 void AppWindow::newFile()
 {

 }

 void AppWindow::open()
 {

 }

 bool AppWindow::save()
 {

 }

 bool AppWindow::saveAs()
 {

 }

 void AppWindow::createActions()
 {
     newAct = new QAction(QIcon(":/images/new.png"), tr("&New"), this);
     newAct->setShortcuts(QKeySequence::New);
     newAct->setStatusTip(tr("Create a new file"));
     connect(newAct, SIGNAL(triggered()), this, SLOT(newFile()));

     openAct = new QAction(QIcon(":/images/open.png"), tr("&Open..."), this);
     openAct->setShortcuts(QKeySequence::Open);
     openAct->setStatusTip(tr("Open an existing file"));
     connect(openAct, SIGNAL(triggered()), this, SLOT(open()));

     saveAct = new QAction(QIcon(":/images/save.png"), tr("&Save"), this);
     saveAct->setShortcuts(QKeySequence::Save);
     saveAct->setStatusTip(tr("Save the document to disk"));
     connect(saveAct, SIGNAL(triggered()), this, SLOT(save()));

     saveAsAct = new QAction(tr("Save &As..."), this);
     saveAsAct->setShortcuts(QKeySequence::SaveAs);
     saveAsAct->setStatusTip(tr("Save the document under a new name"));
     connect(saveAsAct, SIGNAL(triggered()), this, SLOT(saveAs()));

     exitAct = new QAction(tr("E&xit"), this);
     exitAct->setShortcuts(QKeySequence::Quit);
     exitAct->setStatusTip(tr("Exit the application"));
     connect(exitAct, SIGNAL(triggered()), this, SLOT(close()));


     menuBar()->addSeparator();

 }

 void AppWindow::createToolBars()
 {
     fileToolBar = addToolBar(tr("File"));
     fileToolBar->addAction(newAct);
     fileToolBar->addAction(openAct);
     fileToolBar->addAction(saveAct);


 }

 void AppWindow::createStatusBar()
 {
     statusBar()->showMessage(tr("Ready"));
 }

 void AppWindow::readSettings()
 {

 }

 void AppWindow::writeSettings()
 {

 }

 bool AppWindow::maybeSave()
 {

     return true;
 }


 void AppWindow::createMenus()
 {
    fileMenu = menuBar()->addMenu(tr("&File"));
    fileMenu->addAction(newAct);
    fileMenu->addAction(openAct);
    fileMenu->addAction(saveAct);
    fileMenu->addAction(saveAsAct);
    fileMenu->addSeparator();
    fileMenu->addAction(exitAct);
 }
