#include "appwindow.h"
#include "workspace.h"
#include "filterloader.h"

#include <QDockWidget>
#include <QToolBar>
#include <QFileDialog>
#include <QDockWidget>
#include <QMenuBar>



AppWindow::AppWindow(QWidget *parent):QMainWindow(parent)
{
    //Creates the workspace objec
    mWorkspace=new Workspace();

    //Creates the Filter Handler Object and Connect the Signals
 //   mFilterHandle=new FilterLoader(this);
 //   connect(mFilterHandle,SIGNAL(filterReady(QString,QString)),this,SLOT(onFilterReady(QString,QString)));
  //  mFilterHandle->loadFilters();

    //Temporary
    QDockWidget *dockWidget = new QDockWidget(tr("Dock Widget"), this);
    dockWidget->setAllowedAreas(Qt::LeftDockWidgetArea | Qt::RightDockWidgetArea);
    dockWidget->setWidget(mWorkspace);
    addDockWidget(Qt::BottomDockWidgetArea, dockWidget);
    setCentralWidget(dockWidget);
    //Imple Over
    //UI Definion
    createActions();
    createMenus();
    createToolBars();
    createStatusBar();
    readSettings();
}

 void AppWindow::newFile()
 {

 }

 void AppWindow::open()
 {
    QString fileName=QFileDialog::getOpenFileName(this,tr("Open Image"), "/home/everyourgokul/Desktop/", tr("Image Files (*.png *.jpg *.bmp)"));
    mWorkspace->loadImage(fileName);
 }

 void AppWindow::onFilterReady(QString name,QString id)
 {
    //here we need to add the name into the filters menu

 }

 bool AppWindow::save()
 {

 }

 bool AppWindow::saveAs()
 {

 }

 void AppWindow::createActions()
 {
     newAct = new QAction(QIcon(":/images/new.png"), tr("&New"), this);
     newAct->setShortcuts(QKeySequence::New);
     newAct->setStatusTip(tr("Create a new file"));
     connect(newAct, SIGNAL(triggered()), this, SLOT(newFile()));

     openAct = new QAction(QIcon(":/images/open.png"), tr("&Open..."), this);
     openAct->setShortcuts(QKeySequence::Open);
     openAct->setStatusTip(tr("Open an existing file"));
     connect(openAct, SIGNAL(triggered()), this, SLOT(open()));

     saveAct = new QAction(QIcon(":/images/save.png"), tr("&Save"), this);
     saveAct->setShortcuts(QKeySequence::Save);
     saveAct->setStatusTip(tr("Save the document to disk"));
     connect(saveAct, SIGNAL(triggered()), this, SLOT(save()));

     saveAsAct = new QAction(tr("Save &As..."), this);
     saveAsAct->setShortcuts(QKeySequence::SaveAs);
     saveAsAct->setStatusTip(tr("Save the document under a new name"));
     connect(saveAsAct, SIGNAL(triggered()), this, SLOT(saveAs()));

     exitAct = new QAction(tr("E&xit"), this);
     exitAct->setShortcuts(QKeySequence::Quit);
     exitAct->setStatusTip(tr("Exit the application"));
     connect(exitAct, SIGNAL(triggered()), this, SLOT(close()));


     menuBar()->addSeparator();

 }

 void AppWindow::createToolBars()
 {
     fileToolBar = addToolBar(tr("File"));
     fileToolBar->addAction(newAct);
     fileToolBar->addAction(openAct);
     fileToolBar->addAction(saveAct);


 }

 void AppWindow::createStatusBar()
 {
     statusBar()->showMessage(tr("Ready"));
 }

 void AppWindow::readSettings()
 {

 }

 void AppWindow::writeSettings()
 {

 }

 bool AppWindow::maybeSave()
 {

     return true;
 }


 void AppWindow::createMenus()
 {
    fileMenu = menuBar()->addMenu(tr("&File"));
    fileMenu->addAction(newAct);
    fileMenu->addAction(openAct);
    fileMenu->addAction(saveAct);
    fileMenu->addAction(saveAsAct);
    fileMenu->addSeparator();
    fileMenu->addAction(exitAct);
 }
