#include "autocolorfilter.h"
#include <QImage>
#include <QColor>
#include <QDebug>
AutoColorFilter::AutoColorFilter()
{
}
void AutoColorFilter::applyFilter(QImage &image)
{
        int outputRed,outputGreen,outputBlue,cg,dr,dg,db,inputRed,inputBlue,inputGreen;
    for(int i=0;i<image.width();i++)
        for(int j=0;j<image.height();j++)
        {
            QColor inPixel(image.pixel(i,j));
            inputRed=inPixel.red();
            inputBlue=inPixel.blue();
            inputGreen=inPixel.green();

            cg=(inputBlue+inputGreen+inputRed)/3;
            dr=inputRed-cg;
            dg=inputGreen-cg;
            db=inputBlue-cg;

            outputBlue=inputBlue-dr;
            outputGreen=inputGreen-dg;
            outputRed=inputRed-dr;

            if(outputBlue<0) outputBlue=0;
            if(outputGreen<0) outputGreen=0;
            if(outputRed<0) outputRed=0;

            if(outputBlue>255) outputBlue=255;
            if(outputGreen>255) outputGreen=255;
            if(outputRed>255) outputRed=255;


            QColor outPixel(outputRed,outputGreen,outputBlue);
            image.setPixel(i,j,outPixel.rgb());
    }

}
